-(void)applyAPFSPatch {
    NSString *bsdName = [self getAPFSPhysicalStoreForVolumeAtPath:volumePath];
    NSString *diskName = [bsdName substringFromIndex:4];
    NSInteger diskNum = [diskName substringToIndex:[bsdName rangeOfString:@"s"].location-1].integerValue;
    NSString *ESPDisk = [NSString stringWithFormat:@"disk%lds1", diskNum];
    NSString *volumeUUID = [self getUUIDOfVolumeAtPath:volumePath];
    NSString *prebootDisk = [self getPrebootVolumeforAPFSVolumeAtPath:volumePath];
    
    NSString *scriptHeader = [NSString stringWithContentsOfFile:[resourcePath stringByAppendingPathComponent:@"EFIScriptHeader.txt"] encoding:NSUTF8StringEncoding error:nil];
    NSString *mainScript = [NSString stringWithContentsOfFile:[resourcePath stringByAppendingPathComponent:@"EFIScriptMain.txt"] encoding:NSUTF8StringEncoding error:nil];
    NSString *scriptToWrite = [NSString stringWithFormat:@"%@\nset targetUUID \"%@\"\n%@", scriptHeader, volumeUUID, mainScript];
    
    NSArray *args = [[NSArray alloc]initWithObjects:@"mount", ESPDisk, nil];
    NSTask *mount = [[NSTask alloc] init];
    [mount setLaunchPath:@"/usr/sbin/diskutil"];
    [mount setArguments:args];
    [mount launch];
    [mount waitUntilExit];
    args = [[NSArray alloc]initWithObjects:@"mount", prebootDisk, nil];
    mount = [[NSTask alloc] init];
    [mount setLaunchPath:@"/usr/sbin/diskutil"];
    [mount setArguments:args];
    [mount launch];
    [mount waitUntilExit];
    
    if (![[NSFileManager defaultManager] fileExistsAtPath:@"/Volumes/EFI/EFI/BOOT"])
    {
        [[NSFileManager defaultManager] createDirectoryAtPath:@"/Volumes/EFI/EFI/BOOT" withIntermediateDirectories:YES attributes:nil error:nil];
    }
    
    [scriptToWrite writeToFile:@"/Volumes/EFI/EFI/BOOT/startup.nsh" atomically:YES encoding:NSUnicodeStringEncoding error:nil];
    
    args = [[NSArray alloc]initWithObjects:volumePath, resourcePath, volumeUUID, nil];
    NSTask *task = [[NSTask alloc] init];
    [task setLaunchPath:[resourcePath stringByAppendingString:@"/apfsPatch.sh"]];
    [task setArguments:args];
    [task launch];
    [task waitUntilExit];
    
    
    args = [[NSArray alloc]initWithObjects:@"unmount", ESPDisk, nil];
    NSTask *unmount = [[NSTask alloc] init];
    [unmount setLaunchPath:@"/usr/sbin/diskutil"];
    [unmount setArguments:args];
    [unmount launch];
    [unmount waitUntilExit];
    args = [[NSArray alloc]initWithObjects:@"unmount", prebootDisk, nil];
    unmount = [[NSTask alloc] init];
    [unmount setLaunchPath:@"/usr/sbin/diskutil"];
    [unmount setArguments:args];
    [unmount launch];
    [unmount waitUntilExit];
}